﻿DECLARE @@ManifestNo VARCHAR(12) = @0,
@@ManifestReceiveFlag INT, 
	    @@ProblemFlag INT
SELECT @@ManifestReceiveFlag = ISNULL(MANIFEST_RECEIVE_FLAG, 0), @@ProblemFlag=ISNULL(PROBLEM_FLAG, 0) FROM TB_R_DAILY_ORDER_MANIFEST WHERE MANIFEST_NO = @@ManifestNo	 
--SELECT PROBLEM_FLAG FROM dbo.[TB_R_DAILY_ORDER_MANIFEST]   WHERE MANIFEST_NO='1201300001'
IF (@@ManifestReceiveFlag=2 AND @@ProblemFlag=1)
BEGIN
	PRINT '2'
	SELECT
		No=ROW_NUMBER() OVER(ORDER BY CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END DESC,
	CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE not LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END,
	CASE WHEN om.DOCK_CD <> '4B' OR om.DOCK_CD <> '4N' THEN 
	MAX(op.KANBAN_NO)	 
	END),
		pp.PART_NO,
		KANBAN_NO,
		op.PART_NAME,
		ORDER_QTY=SUM(ISNULL(pp.ORDER_QTY, 0)),
		RECEIVED_QTY=SUM(ISNULL(pp.ORDER_QTY, 0)),
		pp.RECEIVED_STATUS,
		ALREADY_RECEIVED_QTY = CASE
		WHEN pp.RECEIVED_STATUS = 0 THEN 0 
		ELSE SUM(ISNULL(pp.ORDER_QTY, 0))
		END,
		CAST(op.ORDER_PLAN_QTY_LOT as int) as PCS_PER_KBN,
		CAST(op.QTY_PER_CONTAINER as int) as NO_OF_KBN,
		RECEIVED_QTY=SUM(ISNULL(pp.ORDER_QTY, 0))-SUM(ISNULL(pp.SHORTAGE_QTY,0))-SUM(ISNULL(pp.MISSPART_QTY,0))-SUM(ISNULL(pp.DAMAGE_QTY,0)),
		--RECEIVED_KBN=(pp.RECEIVED_QTY / op.ORDER_PLAN_QTY_LOT),
		RECEIVED_KBN = (SELECT COUNT(r.KANBAN_ID) FROM TB_R_RECEIVING_D r WHERE MANIFEST_NO = @@ManifestNo AND r.PART_NO = pp.PART_NO AND r.RECEIVING_FLG = '1'),
		SHORTAGE_QTY=SUM(ISNULL(pp.SHORTAGE_QTY,0)),
		SHORTAGE_KBN=(CASE WHEN (CAST(SUM(ISNULL(pp.SHORTAGE_QTY,0)) as INT) / CAST(op.QTY_PER_CONTAINER as INT)) > (SUM(ISNULL(pp.SHORTAGE_QTY,0)) / op.QTY_PER_CONTAINER) THEN (SUM(ISNULL(pp.SHORTAGE_QTY,0)) /op.QTY_PER_CONTAINER) + 1 ELSE (SUM(ISNULL(pp.SHORTAGE_QTY,0)) / op.QTY_PER_CONTAINER) END),
		MISSPART_QTY=SUM(ISNULL(pp.MISSPART_QTY,0)),
		MISSPART_KBN=(CASE WHEN (CAST(SUM(ISNULL(pp.MISSPART_QTY,0)) as INT) / CAST(op.QTY_PER_CONTAINER as INT)) > (SUM(ISNULL(pp.MISSPART_QTY,0)) / op.QTY_PER_CONTAINER) THEN (SUM(ISNULL(pp.MISSPART_QTY,0)) / op.QTY_PER_CONTAINER) + 1 ELSE (SUM(ISNULL(pp.MISSPART_QTY,0)) / op.QTY_PER_CONTAINER) END),
		DAMAGE_QTY=SUM(ISNULL(pp.DAMAGE_QTY,0)),
		DAMAGE_KBN = (CASE WHEN (CAST(SUM(ISNULL(pp.DAMAGE_QTY,0)) as INT) / CAST(op.QTY_PER_CONTAINER as INT)) > (SUM(ISNULL(pp.DAMAGE_QTY,0)) / op.QTY_PER_CONTAINER) THEN (SUM(ISNULL(pp.DAMAGE_QTY,0)) /op.QTY_PER_CONTAINER) + 1 ELSE (SUM(ISNULL(pp.DAMAGE_QTY,0)) / op.QTY_PER_CONTAINER) END),
		Notice='0',
		ISNULL(om.PROBLEM_FLAG, 0) PROBLEM_FLAG
	FROM TB_R_PROBLEM_PART pp 
	LEFT OUTER JOIN TB_R_DAILY_ORDER_MANIFEST om ON om.MANIFEST_NO = pp.MANIFEST_NO
	LEFT OUTER JOIN dbo.TB_R_DAILY_ORDER_PART op ON op.MANIFEST_NO = pp.MANIFEST_NO AND op.PART_NO = pp.PART_NO
	WHERE pp.MANIFEST_NO=@@ManifestNo AND SOLVED_FLAG=0
	GROUP BY --pp.ITEM_NO,
		pp.PART_NO,
		op.PART_NAME,
		op.KANBAN_NO,
		pp.RECEIVED_STATUS,
		om.PROBLEM_FLAG,
		op.ORDER_PLAN_QTY_LOT,
		op.QTY_PER_CONTAINER,
		pp.RECEIVED_QTY,
		om.DOCK_CD,
		op.PACKAGE_TYPE
	ORDER BY CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END DESC,
	CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE not LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END,
	CASE WHEN om.DOCK_CD <> '4B' OR om.DOCK_CD <> '4N' THEN 
	MAX(op.KANBAN_NO)	 
	END
END
ELSE
BEGIN
	PRINT 'BUKAN 2'
	SELECT
		No=ROW_NUMBER() OVER(ORDER BY CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END DESC,
	CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE not LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END,
	CASE WHEN om.DOCK_CD <> '4B' OR om.DOCK_CD <> '4N' THEN 
	MAX(op.KANBAN_NO)	 
	END),
		--op.ITEM_NO,
		op.PART_NO,
		KANBAN_NO,
		op.PART_NAME,
		CAST(op.ORDER_PLAN_QTY_LOT as int) as PCS_PER_KBN,
		CAST(op.QTY_PER_CONTAINER as int) as NO_OF_KBN,
		ORDER_QTY=SUM(op.ORDER_QTY),
		om.MANIFEST_RECEIVE_FLAG RECEIVED_STATUS,
		RECEIVED_QTY=SUM(op.ORDER_QTY),
		RECEIVED_KBN=SUM(op.ORDER_PLAN_QTY_LOT),
		--ISNULL(om.PROBLEM_FLAG, 0) PROBLEM_FLAG,
		--ALREADY_RECEIVED_QTY = CASE
		--WHEN op.RECEIVED_STATUS = 0 THEN 0 
		--ELSE SUM(op.ORDER_QTY)
		--END,
		Notice='0'
	FROM TB_R_DAILY_ORDER_PART op 
	INNER JOIN TB_R_DAILY_ORDER_MANIFEST om ON 
	om.MANIFEST_NO = op.MANIFEST_NO
	WHERE op.MANIFEST_NO=@@ManifestNo
	GROUP BY
		op.PART_NO,
		op.PART_NAME,
		op.KANBAN_NO,
		om.MANIFEST_RECEIVE_FLAG,
		op.ORDER_PLAN_QTY_LOT,
		op.QTY_PER_CONTAINER,
		om.DOCK_CD,
		op.PACKAGE_TYPE
	HAVING SUM(op.ORDER_QTY) > 0
	ORDER BY CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END DESC,
	CASE WHEN om.DOCK_CD = '4B' OR om.DOCK_CD = '4N' THEN 
	CASE WHEN op.PACKAGE_TYPE not LIKE 'TP%' THEN op.PACKAGE_TYPE END		 
	END,
	CASE WHEN om.DOCK_CD <> '4B' OR om.DOCK_CD <> '4N' THEN 
	MAX(op.KANBAN_NO)	 
	END
END


